-- name: [CS] \\#32BCC6\\Miku\\#FFFFFF\\ and\\#FF273E\\ Teto
-- description: The Cheerful Vocaloid, \\#32BCC6\\Hatsune Miku\\#FFFFFF\\, and her eager but also mischievous friend, \\#FF273E\\Kasane Teto\\#FFFFFF\\, both arrive in the low poly world of the Mushshroom Kingdom, will the singing duet be able to grab all the stars and save the Princess from the Koopa Clan leader, Bowser?\n\n\\\#FCBA03\\WARNING: This mod might have a person who has Blue Hair, Blue Tie, hiding in your Wi-Fi!\n\n\\\#FFFFFF\\Made by VioletArts

local TEXT_MOD_NAME = "Miku and Teto"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MIKU_MODEL = smlua_model_util_get_id("miku_violet_geo")
local E_BRAZILMIKU_MODEL = smlua_model_util_get_id("brazilmiku_violet_geo")
local E_MARIOMIKU_MODEL = smlua_model_util_get_id("mariomiku_violet_geo")
local E_MESMIKU_MODEL = smlua_model_util_get_id("mesmiku_violet_geo")

local E_TETO_MODEL = smlua_model_util_get_id("teto_violet_geo")
local E_SYNTHTETO_MODEL = smlua_model_util_get_id("synthteto_violet_geo")
local E_MESTETO_MODEL = smlua_model_util_get_id("mesteto_violet_geo")
local E_LUIGITETO_MODEL = smlua_model_util_get_id("luigiteto_violet_geo")

local TEX_MIKU_ICON = get_texture_info("miku_violet_icon")
local TEX_TETO_ICON = get_texture_info("teto_violet_icon")

local VOICETABLE_MIKU = {
    [CHAR_SOUND_OKEY_DOKEY] = 'MikuOkieDokie.ogg',
    [CHAR_SOUND_ATTACKED] = 'MikuAttacked.ogg',
    [CHAR_SOUND_COUGHING3] = 'MikuCough.ogg',
    [CHAR_SOUND_DOH] = 'MikuDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'MikuDrown.ogg',
    [CHAR_SOUND_DYING] = 'MikuDead.ogg',
    [CHAR_SOUND_EEUH] = 'MikuEeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'MikuWah.ogg',
    [CHAR_SOUND_HAHA] = 'MikuHaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'MikuHaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'MikuSugoi.ogg',
    [CHAR_SOUND_HOOHOO] = 'MikuHooHoo.ogg',
    [CHAR_SOUND_HRMM] = 'MikuGrab.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'MikuTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'MikuLetsDoThis.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'MikuOhNo.ogg',
    [CHAR_SOUND_ON_FIRE] = 'MikuBurning.ogg',
    [CHAR_SOUND_OOOF] = 'MikuOof.ogg',
    [CHAR_SOUND_OOOF2] = 'MikuOof.ogg',
    [CHAR_SOUND_PANTING] = 'MikuPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'MikuPanting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'MikuHoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'MikuWah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'MikuYah.ogg',
    [CHAR_SOUND_SNORING1] = 'MikuSnore1.ogg',
    [CHAR_SOUND_SNORING2] = 'MikuSnore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'MikuBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'MikuBoing.ogg',
    [CHAR_SOUND_UH] = 'MikuUh.ogg',
    [CHAR_SOUND_UH2] = 'MikuUh.ogg',
    [CHAR_SOUND_UH2_2] = 'MikuUh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'MikuYell.ogg',
    [CHAR_SOUND_WHOA] = 'MikuWoah.ogg',
    [CHAR_SOUND_YAHOO] = 'MikuYahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'MikuYahoo.ogg', 'MikuWaha.ogg', 'MikuYippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'MikuYah.ogg', 'MikuWah.ogg', 'MikuHoo.ogg'},
    [CHAR_SOUND_YAWNING] = 'MikuYawn.ogg',
}

local VOICETABLE_TETO = {
    [CHAR_SOUND_OKEY_DOKEY] = 'TetoOkieDokie.ogg',
    [CHAR_SOUND_ATTACKED] = 'TetoAttacked.ogg',
    [CHAR_SOUND_COUGHING3] = 'TetoCough.ogg',
    [CHAR_SOUND_DOH] = 'TetoDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'TetoDrown.ogg',
    [CHAR_SOUND_DYING] = 'TetoDead.ogg',
    [CHAR_SOUND_EEUH] = 'TetoEeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'TetoWah.ogg',
    [CHAR_SOUND_HAHA] = 'TetoHaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'TetoHaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'TetoHereWeGo.ogg',
    [CHAR_SOUND_HOOHOO] = 'TetoHooHoo.ogg',
    [CHAR_SOUND_HRMM] = 'TetoGrab.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'TetoTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'TetoLetsDoThis.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'TetoOhNo.ogg',
    [CHAR_SOUND_ON_FIRE] = 'TetoBurning.ogg',
    [CHAR_SOUND_OOOF] = 'TetoOof.ogg',
    [CHAR_SOUND_OOOF2] = 'TetoOof.ogg',
    [CHAR_SOUND_PANTING] = 'TetoPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'TetoPanting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'TetoHoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'TetoWah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'TetoYah.ogg',
    [CHAR_SOUND_SNORING1] = 'TetoSnore1.ogg',
    [CHAR_SOUND_SNORING2] = 'TetoSnore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'TetoBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'TetoBoing.ogg',
    [CHAR_SOUND_UH] = 'TetoUh.ogg',
    [CHAR_SOUND_UH2] = 'TetoUh.ogg',
    [CHAR_SOUND_UH2_2] = 'TetoUh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'TetoYell.ogg',
    [CHAR_SOUND_WHOA] = 'TetoWoah.ogg',
    [CHAR_SOUND_YAHOO] = 'TetoYahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'TetoYahoo.ogg', 'TetoWaha.ogg', 'TetoYippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'TetoYah.ogg', 'TetoWah.ogg', 'TetoHoo.ogg'},
    [CHAR_SOUND_YAWNING] = 'TetoYawn.ogg',
}

local MIKU_PALETTE = {
    [PANTS] = "233139",
    [SHIRT] = "BBBFCA",
    [GLOVES] = "233139",
    [SHOES] = "233139",
    [HAIR] = "32BCC6",
    [SKIN] = "FFBD97",
    [CAP] = "32BCC6",
    [EMBLEM] = "32BCC6"
}

local BRAZILMIKU_PALETTE = {
    [PANTS] = "304161",
    [SHIRT] = "FFB000",
    [GLOVES] = "FFFFFF",
    [SHOES] = "FFFFFF",
    [HAIR] = "32BCC6",
    [SKIN] = "FE8C50",
    [CAP] = "3BAD32",
    [EMBLEM] = "F2D700"
}

local MARIOMIKU_PALETTE = {
    [PANTS] = "0000FF",
    [SHIRT] = "FF0000",
    [GLOVES] = "FFFFFF",
    [SHOES] = "721C0E",
    [HAIR] = "32BCC6",
    [SKIN] = "FFBD97",
    [CAP] = "FF0000",
    [EMBLEM] = "FF0000"
}

local MESMIKU_PALETTE = {
    [PANTS] = "FFFFFF",
    [SHIRT] = "3250FF",
    [GLOVES] = "FFD300",
    [SHOES] = "FF2828",
    [HAIR] = "32BCC6",
    [SKIN] = "FFBD97",
    [CAP] = "FFFFFF",
    [EMBLEM] = "FF2828"
}

local TETO_PALETTE = {
    [PANTS] = "374155",
    [SHIRT] = "374155",
    [GLOVES] = "374155",
    [SHOES] = "14171F",
    [HAIR] = "FF273E",
    [SKIN] = "FED7A4",
    [CAP] = "FF273E",
    [EMBLEM] = "FF2D4B"
}

local SYNTHTETO_PALETTE = {
    [PANTS] = "D1D1CB",
    [SHIRT] = "D1D1CB",
    [GLOVES] = "374155",
    [SHOES] = "14171F",
    [HAIR] = "FF273E",
    [SKIN] = "FED7A4",
    [CAP] = "FF273E",
    [EMBLEM] = "FF2D4B"
}

local MESTETO_PALETTE = {
    [PANTS] = "FF0023",
    [SHIRT] = "FFFFFF",
    [GLOVES] = "FFEB1A",
    [SHOES] = "14171F",
    [HAIR] = "FF273E",
    [SKIN] = "FED7A4",
    [CAP] = "FF0023",
    [EMBLEM] = "3CA0FF"
}

local LUIGITETO_PALETTE = {
    [PANTS] = "0000FF",
    [SHIRT] = "00FF00",
    [GLOVES] = "FFFFFF",
    [SHOES] = "721C0E",
    [HAIR] = "FF273E",
    [SKIN] = "FED7A4",
    [CAP] = "00FF00",
    [EMBLEM] = "00FF00"
}

local MIKU_CAPMODELS = {
    normal = smlua_model_util_get_id("miku_violet_cap_geo"),
    wing = smlua_model_util_get_id("miku_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("miku_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("miku_violet_cap_metal_wing_geo"),
}

local TETO_CAPMODELS = {
    normal = smlua_model_util_get_id("teto_violet_cap_geo"),
    wing = smlua_model_util_get_id("teto_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("teto_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("teto_violet_cap_metal_wing_geo"),
}

local HEALTH_METER_MIKU = {
    label = {
        left = get_texture_info("MikuLeft"),
        right = get_texture_info("MikuRight"),
    },
    pie = {
        [1] = get_texture_info("Miku-1"),
        [2] = get_texture_info("Miku-2"),
        [3] = get_texture_info("Miku-3"),
        [4] = get_texture_info("Miku-4"),
        [5] = get_texture_info("Miku-5"),
        [6] = get_texture_info("Miku-6"),
        [7] = get_texture_info("Miku-7"),
        [8] = get_texture_info("Miku-8"),
    }
}

local charSelectLoaded = false
local function on_character_select_load()
    CT_MIKU = _G.charSelect.character_add("Hatsune Miku", {"The Cheerful Vocaloid, Hastune Miku,", "makes her debut on the", "big stage, but this time", "in a bit of low poly", "form, can Miku make her", "way to super stardom and", "defeat Bowser?"}, "Violet", {r = 67, g = 185, b = 255}, E_MIKU_MODEL, CT_TOAD, TEX_MIKU_ICON)
    _G.charSelect.character_add_voice(E_MIKU_MODEL, VOICETABLE_MIKU)
    _G.charSelect.character_add_palette_preset(E_MIKU_MODEL, MIKU_PALETTE)
    _G.charSelect.character_add_caps(E_MIKU_MODEL, MIKU_CAPMODELS)
    _G.charSelect.character_add_health_meter(CT_MIKU, HEALTH_METER_MIKU)
    
    _G.charSelect.character_add_costume(CT_MIKU, "Brazilian Miku", nil, "Violet", nil, E_BRAZILMIKU_MODEL, CT_TOAD, TEX_MIKU_ICON, nil, nil)
    _G.charSelect.character_add_voice(E_BRAZILMIKU_MODEL, VOICETABLE_MIKU)
    _G.charSelect.character_add_palette_preset(E_BRAZILMIKU_MODEL, BRAZILMIKU_PALETTE)
    _G.charSelect.character_add_caps(E_BRAZILMIKU_MODEL, MIKU_CAPMODELS)

    _G.charSelect.character_add_costume(CT_MIKU, "Mario Miku", nil, "Violet", nil, E_MARIOMIKU_MODEL, CT_MARIO, TEX_MIKU_ICON, nil, nil)
    _G.charSelect.character_add_voice(E_MARIOMIKU_MODEL, VOICETABLE_MIKU)
    _G.charSelect.character_add_palette_preset(E_MARIOMIKU_MODEL, MARIOMIKU_PALETTE)

    _G.charSelect.character_add_costume(CT_MIKU, "Mesmerizer Miku", nil, "Violet", nil, E_MESMIKU_MODEL, CT_TOAD, TEX_MIKU_ICON, nil, nil)
    _G.charSelect.character_add_voice(E_MESMIKU_MODEL, VOICETABLE_MIKU)
    _G.charSelect.character_add_palette_preset(E_MESMIKU_MODEL, MESMIKU_PALETTE)
    _G.charSelect.character_add_caps(E_MESMIKU_MODEL, MIKU_CAPMODELS)

    CT_TETO = _G.charSelect.character_add("Kasane Teto", {"Kasane Teto, the utaloid singer", "is here! With her red twin", "drill hair, she is ready", "to sing with Hatsune Miku", "in this low poly world!"}, "Violet", {r = 255, g = 39, b = 62}, E_TETO_MODEL, CT_TOAD, TEX_TETO_ICON)
    _G.charSelect.character_add_palette_preset(E_TETO_MODEL, TETO_PALETTE)
    _G.charSelect.character_add_voice(E_TETO_MODEL, VOICETABLE_TETO)
    _G.charSelect.character_add_caps(E_TETO_MODEL, TETO_CAPMODELS)
    _G.charSelect.character_add_health_meter(CT_TETO, HEALTH_METER_MIKU)

    _G.charSelect.character_add_costume(CT_TETO, "SynthV Teto", nil, "Violet", nil, E_SYNTHTETO_MODEL, CT_TOAD, TEX_TETO_ICON, nil, nil)
    _G.charSelect.character_add_palette_preset(E_SYNTHTETO_MODEL, SYNTHTETO_PALETTE)
    _G.charSelect.character_add_voice(E_SYNTHTETO_MODEL, VOICETABLE_TETO)
    _G.charSelect.character_add_caps(E_SYNTHTETO_MODEL, TETO_CAPMODELS)

    _G.charSelect.character_add_costume(CT_TETO, "Mesmerizer Teto", nil, "Violet", nil, E_MESTETO_MODEL, CT_TOAD, TEX_TETO_ICON, nil, nil)
    _G.charSelect.character_add_palette_preset(E_MESTETO_MODEL, MESTETO_PALETTE)
    _G.charSelect.character_add_voice(E_MESTETO_MODEL, VOICETABLE_TETO)
    _G.charSelect.character_add_caps(E_MESTETO_MODEL, TETO_CAPMODELS)

    _G.charSelect.character_add_costume(CT_TETO, "Luigi Teto", nil, "Violet", nil, E_LUIGITETO_MODEL, CT_LUIGI, TEX_TETO_ICON, nil, nil)
    _G.charSelect.character_add_palette_preset(E_LUIGITETO_MODEL, LUIGITETO_PALETTE)
    _G.charSelect.character_add_voice(E_LUIGITETO_MODEL, VOICETABLE_TETO)

    if _G.charSelect.credit_add then
        _G.charSelect.credit_add(globalModName, "VioletArts", "Pack Creator")
        _G.charSelect.credit_add(globalModName, "chalz", "Miku/Teto Voicelines")
    end

    charSelectLoaded = true
end

local function on_character_sound(m, sound)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MIKU then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_TETO then return _G.charSelect.voice.sound(m, sound) end
end
local function on_character_snore(m)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MIKU then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_TETO then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)